<?php
/*********************/
/*                   */
/*  Version : 5.1.0  */
/*  Author  : RM     */
/*  Comment : 071223 */
/*                   */
/*********************/

function check_inject( )
{
    $badchars = array( ";", "'", "*", "/", " \\ ", "DROP", "SELECT", "UPDATE", "DELETE", "drop", "select", "update", "delete", "WHERE", "webzen", "web_zen", "WebZen", "where", "-1", "-2", "-3", "-4", "-5", "-6", "-7", "-8", "-9" );
    foreach ( $GLOBALS['_POST'] as $value )
    {
        $value = clean_variable( $value );
        if ( in_array( $value, $badchars ) )
        {
            exit( "SQL Injection Detected - Make sure only to use letters and numbers!\n<br />\nIP: ".$_SERVER['REMOTE_ADDR'] );
        }
        $check = preg_split( "//", $value, -1, PREG_SPLIT_OFFSET_CAPTURE );
        foreach ( $check as $char )
        {
            if ( !in_array( $char, $badchars ) )
            {
                continue;
            }
            exit( "SQL Injection Detected - Make sure only to use letters and numbers!\n<br />\nIP: ".$_SERVER['REMOTE_ADDR'] );
        }
    }
}

function clean_variable( $var )
{
    $newvar = preg_replace( "/[^a-zA-Z0-9\\_\\-]/", "", $var );
    return $newvar;
}

?>
